<?php
	class html {
		function html() {
			// Not needed
		}

		function html_attributes($html) {
			foreach ($html as $k=>$v) {
				if (strtolower($k) == 'checked' || strtolower($k) == 'selected') {
					echo ' '.$k;
					continue;
				}
				echo ' '.$k.'="'.ent($v).'"';
			}
		}

		function select($html, $value_text, $value = '') {

			ob_start();
			?><select<?php
				$this->html_attributes($html);
			?>><?php
				foreach ($value_text as $v=>$text) {
					?><option value="<?php eent($v); ?>"<?php
						if ($v == $value) {
							echo ' selected';
						}
					?>><?php eent($text); ?></option><?php
				}
			?></select><?php
			return ob_get_clean();
		}

		function radio($html, $value_text, $value = '') {
			$radios = array();
			/*
				<INPUT TYPE=RADIO NAME="pizzasize" VALUE="S">small<BR>
				<INPUT TYPE=RADIO NAME="pizzasize" VALUE="M">medium<BR>
				<INPUT TYPE=RADIO NAME="pizzasize" VALUE="L">large<P>
			 */
			 $cnt = 0;
			foreach ($value_text as $v=>$text) {
				if (!$v && !$text) {
					continue;
				}
				ob_start();
				?><input type="radio"<?php
					$html['id'] = $html['name'].'['.$cnt.']';
					$this->html_attributes($html);
				?> value="<?php eent($v); ?>"<?php
					if ($v == $value) {
						echo ' checked';
					}
				?>><?php
					// We echo *raw* text for a <label for=""> tag or
					// <a onClick="">
					echo $this->label($html,$text).'<br />';
				$radios[] = ob_get_clean();
				$cnt++;
			}
			return $radios;
		}

		function a($html, $text) {
			ob_start();
			?><a<?php
				$this->html_attributes($html);
			?>><?php echo $text; ?></a><?php
			return ob_get_clean();
		}

		function textarea($html, $value) {
			ob_start();
			?><textarea<?php
				$this->html_attributes($html);
			?>><?php eent($value); ?></textarea><?php
			return ob_get_clean();
		}

		function checkbox($html, $checked, $text, $label = true, $orient = 'right') {
			$html['type'] = 'checkbox';
			if ($checked) {
				$html['checked'] = 'checked';
			}
			if ($orient == 'right') {
				return $this->label_start($html, $text, $label) . $this->input($html) . $this->label_end($html, $label);
			} else {
				return $this->input($html) . $this->label_start($html, $text, $label). $this->label_end($html, $label);
			}
		}

		function label_start($html, $text, $label) {
			if (!$label) {
				return $text;
			}
			if ($html['id']) {
				$pre = '<label ';
				if ($html['class']) {
					$pre .= 'class="'.$html['class'].'" ';
				}
				$text = $pre.'for="'.ent($html['id']).'">'.$text;
			}
			return $text;
		}

		function label_end($html, $label) {
			if (!$label || !$html['id']) {
				return '';
			}
			return '</label>';
		}

		function input($html) {
			ob_start();
			?><input<?php
				$this->html_attributes($html);
			?>><?php
			return ob_get_clean();
		}

		function hidden($keys_n_values,$pre = '') {
			ob_start();
			foreach ($keys_n_values as $k=>$v) {
				if (is_array($v)) {
					if ($pre) {
						$k = $pre.'['.$k.']';
					}
					echo $this->hidden($v,$k);
					continue;
				}
				if ($pre) {
					$k = $pre.'['.$k.']';
				}
				$html = array('name' => $k, 'value' => $v, 'type' => 'hidden');
				echo $this->input($html);
			}
			return ob_get_clean();
		}

		function validate($value,  $pattern = '', $length = 0) {
			if ($length != 0 && strlen($value) > $length) {
				return -1;
			}
			if (!$pattern) {
				return true;
			}
			if (is_array($pattern)) {
				if (in_array ($value, $pattern)) {
					return true;
				}
				return -2;
			}
			switch($pattern) {
				case 'phone' :
					$pattern = "/(\([2-9]\d{2}\)\s?|[2-9]\d{2}-|[2-9]\d{2})"
					. "[1-9]\d{2}"
					. "-?\d{4}/";
					break;
				case 'is_numeric' :
					if (is_numeric($value)) {
						return true;
					} else {
						if ($length == 0 & $value == '') {
							return true;
						}
						return 0;
					}
					break;
				case 'is_not_numeric' :
					if (!is_numeric($value)) {
						return true;
					} else {
						return 0;
					}
					break;
				case 'email' :
					$pattern = '/^[a-z0-9!#$%&*+-=?^_`{|}~]+(\.[a-z0-9!#$%&*+-=?^_`{|}~]+)*';
					$pattern .= '@([-a-z0-9]+\.)+([a-z]{2,3}';
					$pattern .= '|info|arpa|aero|coop|name|museum)$/ix';
					break;
				default:
					break;
			}
			if (preg_match($pattern, $value)) {
				return true;
			}
			return 0;
		}

		function switch_type($html, $template_data) {
			$return = '';
			switch($template_data['data_type']) {
				case 'textarea':
					$data_validate = $template_data['data_validate'];
					$value = $html['value'];
					unset($html['value']);
					$return .= $this->textarea($html, $value);
					break;
				case 'select':
					$return .= $this->select($html, $this->convert_value_text($template_data['data_attributes']), $html['value']);
					break;
				case 'radio' :
					$value = $html['value'];
					unset($html['value']);
					$return .= implode('',$this->radio($html, $this->convert_value_text($template_data['data_attributes']), $value));
					break;
				case 'password':
					$data_validate = $template_data['data_validate'];
					$html['type'] = 'password';
					$return .= $this->input($html);
					break;
				case 'text':
				default:
					$data_validate = $template_data['data_validate'];
					$html['type'] = 'text';
					$return .= $this->input($html);
					break;
			}
			$valid = $this->validate($html['value'], $data_validate, $template_data['data_length']);
			if ($valid === -1) {
				$return .= '<br /><font color="red">' . ent($template_data['ut_data_name']) . ' is too big.</font>';
			} elseif ($valid === -2) {
				$return .= '<br /><font color="red">' . ent($template_data['ut_data_name']) . ' is not valid. *hacker*</font>';
			} elseif ($valid === 0) {
				$return .= '<br /><font color="red">Invalid ' . ent($template_data['ut_data_name']) .'</font>';
			}
			return $return;
		}

		function convert_value_text($attribute_array) {
			$return = array();
			if (is_string($attribute_array)) {
				$attribute_array = unserialize($attribute_array);
			}
			if ($attribute_array) {
				foreach ($attribute_array as $k=>$v) {
					$return["{$v['value']}"] = $v['text'];
				}
			}
			return $return;
		}



		function switch_attributes($base, $template_data) {
			switch($template_data['data_type']) {
				case 'radio' :
				case 'select':
					if (is_string($template_data['data_attributes'])) {
						$template_data['data_attributes'] = unserialize($template_data['data_attributes']);
					}
					//select($html, $value_text, $value = '')
					ob_start();
					?><table border="1" cellspacing="0">
					<tr>
						<td>Value</td>
						<td>Text</td>
					</tr>
					<?php
					$abase = $base.'[data_attributes]';
					if ($template_data['data_attributes']) {
						$cnt=0;
						foreach ($template_data['data_attributes'] as $k=>$v) {
							if (!$v['value'] && !$v['text']) {
								continue;
							}

							?><tr>
								<td><?php
								echo $this->input(array(
										'type' => 'text',
										'name' => $abase.'['.$cnt.'][value]',
										'value' => $v['value']
									)
								); ?></td>
								<td><?php
								echo $this->input(array(
										'type' => 'text',
										'name' => $abase.'['.$cnt.'][text]',
										'value' => $v['text']
									)
								); ?></td>

							</tr><?php
							$cnt++;
						}

					}
					?><tr>
						<td><?php
						echo $this->input(array(
								'type' => 'text',
								'name' => $abase.'['.$cnt.'][value]',
								'value' => ''
							)
						); ?></td>
						<td><?php
						echo $this->input(array(
								'type' => 'text',
								'name' => $abase.'['.$k.'][text]',
								'value' => ''
							)
						); ?></td>
					</tr>
					<tr>
						<td colspan="2"><?php
						preg_match('/(.*)\[([0-9]{1,100})\]\[([0-9]{1,100}|new)\]/i',$base,$matches);
						if (!$matches) {
							//preg_match('/(.*)\[([0-9]{1,100})\]\[(new)\]/i',$base,$matches);
						}
						if ($matches) {
							$base = $matches[1].'['.$matches[2].']';
							$abase = $base.'['.$matches[3].']';
						}

						echo $this->input(
							array(
								'type' => 'button',
								'onClick' => 'xajax_update_default_n_attributes(xajax.getFormValues("'.$base.'[form]",false,"'.$abase.'"));',
								'value' => 'Add'
							)
						);
						/*Array
						(
							[0] => template_variables[4][2]
							[1] => template_variables
							[2] => 4
						)
						*/
						?></td>
					</tr>
					</table><?php
					return ob_get_clean();
					break;
				default:
					$base = $base.'[data_attributes]';
					if (is_array($template_data['data_attributes'])) {
						$template_data['data_attributes'] = serialize($template_data['data_attributes']);
					}
					return $this->input(
						array(
							'name' => $base,
							'type' => 'hidden',
							'value' => $template_data['data_attributes']
						)
					);
					break;
			}
		}

	}
?>