<?php
// 	global $file_types;

	global $must_convert_ext, $video_ext, $audio_ext;
	$must_convert_ext = array('mpg', 'mpeg', 'mov', 'wmv', 'avi', 'rm', 'wav', 'ogg', 'divx');
	$video_ext = array('mpg','mpeg','mov','flv','wmv','avi','rm','divx');
	$audio_ext = array('mp3','wav','ogg');

	define ('CONVERT_DIR','converted/');

	function ent($string) {
		if (is_array($string) || is_object($string)) {
			return '<pre>'.htmlentities(print_r($string,true), ENT_QUOTES).'</pre>';
		}
		return htmlentities($string, ENT_QUOTES);
	}

	function eent($string) {
		echo ent($string);
	}

	function printr($array) {
		return print_r($array,true);
	}

	function tableify($array) {
		if (!is_array($array)) {
			return ent($array);
		}
		ob_start();
		?><table><?php
		$cnt = 0;
		foreach ($array as $k=>$a) {
			if ($cnt == 0) {
				?><tr><?php
				if (is_array($a) || is_object($a)) {
					foreach ($a as $k2=>$v2) {
						?><td><?php
						eent($k2);
						?></td><?php
					}
				} else {
					?><td><?php
					eent($a);
					?></td><?php
				}
				?></tr><?php
			}
			?><tr<?php
				if ($cnt % 2 == 0) {
					?> style="background: #EEE;"<?php
				}
			?>><?php
			if (is_array($a) || is_object($a)) {
				foreach ($a as $k2=>$v2) {
					?><td><?php
					if (is_array($v2) || is_object($v2)) {
						echo tableify($v2);
					} else {
						eent($v2);
					}
					?></td><?php
				}
			} else {
				?><td><?php
				eent($v2);
				?></td><?php
			}
			?></tr><?php
			$cnt++;
		}
		?></table><?php
		return ob_get_clean();
	}

	function inc($file, $args = array()) {
		global $db, $html, $xajax, $callback;
		if (strpos ($file, '..') !== false || substr($file,0,1) == '/' || substr($file,0,1) == '\\' || empty($file)) {
			// We don't want them to be able to include any file they wish.
			return '';
		}
		if (file_exists(TEMPLATE_DIR.'/'.$file)) {
			include TEMPLATE_DIR.'/'.$file;
		} elseif (file_exists('widget/'.$file)) {
			include 'widget/'.$file;
		}
	}

	function widget($file, $widget_data = array()) {
		global $db, $html, $xajax, $callback;
		if (file_exists('widget/'.$file)) {
			include 'widget/'.$file;
		}
	}

	if (!isset($_SESSION['users'])) {
		$_SESSION['users'] = array();
	}

	function js_escape($string, $quote = "'") {
		$find = array('\\',"\n","\r","\t",$quote);
		$replace = array('\\\\','\n','\r','\t', '\\'.$quote);
		return str_replace($find,$replace, $string);
	}

	function is_admin() {
		foreach ($_SESSION['users'] as $k=>$v) {
			if ($v['admin']) {
				return true;
			}
		}
		return false;
	}

	function extract_artist($file) {
		$file = basename($file);
		if (strpos ($file, '.') !== false) {
			// Remove extension
			$parts = explode('.',$file);
			array_pop($parts);
			$file = implode('.', $parts);
		}
		$file = str_replace('_',' ',$file);
		$parts = explode('-',$file);
		return trim($parts[0]);
	}

	function extract_title($file) {
		$file = basename($file);
		if (strpos ($file, '.') !== false) {
			// Remove extension
			$parts = explode('.',$file);
			array_pop($parts);
			$file = implode('.', $parts);
		}
		$file = str_replace('_',' ',$file);
		$parts = explode('-',$file);
		array_shift($parts);
		return trim(implode(' - ',$parts));
	}

	function get_tags($file) {
		global $objResponse;
		require_once ('getid3/getid3.php');
		$getID3 = new getID3;
		$file = realpath($file);
		ob_start();
		$ThisFileInfo = $getID3->analyze($file);
		getid3_lib::CopyTagsToComments($ThisFileInfo);
		$res = ob_get_clean();
		$info['filename'] = $file;
		$info['path'] = dirname($file);
		$info['basename'] = basename($file);
		$info['fileformat'] = $ThisFileInfo['fileformat'];
		$info['playtime_seconds'] = $ThisFileInfo['playtime_seconds'];
		$info['bitrate'] = $ThisFileInfo['bitrate'];
		$info['sample_rate'] = $ThisFileInfo['audio']['sample_rate'];
		//$info['audio'] = $ThisFileInfo['audio'];
		$a = $ThisFileInfo['comments']['artist'][0];
		$info['artist'] = $a ? $a : extract_artist($file) ;
		$t = $ThisFileInfo['comments']['title'][0];
		$info['title'] = $t ? $t : extract_title($file);
		$g = @array_pop($ThisFileInfo['comments']['genre']);
		$info['genre'] = $g ? $g : '[undefined]';
		$info['track'] = $ThisFileInfo['comments']['track'][0] ? $ThisFileInfo['comments']['track'][0] : '0';
		$y = @array_pop($ThisFileInfo['comments']['year']);
		$info['year'] = $y ? $y : '0';
		$info['filesize'] = filesize($file);
		return $info;
	}

	function update_tags($tags) {
		global $db;
		$tags['filename'] = realpath($tags['filename']);
		/*
			+------------------+
			| Field            |
			+------------------+
			| fid              |
			| aid              |
			| title            |
			| gid              |
			| fileformat       |
			| playtime_seconds |
			| bitrate          |
			| track            |
			| year             |
			| filename         |
			| ltp              |
			| filesize         |
			+------------------+

			+-------+
			| Field |
			+-------+
			| gid   |
			| id1   |
			| genre |
			+-------+
		*/
		/*
			+--------+
			| Field  |
			+--------+
			| aid    |
			| artist |
			| altp   |
			+--------+
		*/
		$artist_info = get_artist_info($tags['artist']);
		if (!$artist_info || empty($artist_info)) {
			$db->insert('artists', $tags);
			$artist_info = get_artist_info($tags['artist']);
		}
		$genre_info = get_genre_info($tags['genre']);
		if (!$genre_info || empty($genre_info)) {
			$db->insert('genres', $tags);
			$genre_info = get_genre_info($tags['genre']);
		}
		$song_info = get_song_info($tags['filename']);
		if (!$song_info || empty($song_info)) {
			$db->insert('files', $tags);
			$song_info = get_song_info($tags['filename']);
		}


		/* SELECT '1','unplayed','11', f.fid FROM files f LEFT JOIN user_song_info u ON f.fid = u.fid AND u.uid = 1 WHERE u.fid IS NULL */

		// $tags have lowest priority
		$tags = array_merge($tags, $song_info, $artist_info, $genre_info);
		$tags['aid'] = $artist_info['aid'];
		$tags['fid'] = $song_info['fid'];
		$tags['gid'] = $genre_info['gid'];

		$finfo = $tags;
		unset ($finfo['fid']);
		$db->update('files', $finfo , "fid = '{$tags['fid']}'", false);
		$finfo = $tags;
		unset ($finfo['aid']);
		$db->update('artists', $finfo , "aid = '{$tags['aid']}'", false);
		$finfo = $tags;
		unset ($finfo['gid']);
		$db->update('genres', $finfo , "gid = '{$tags['gid']}'", false);

	}

	function get_artist_info($artist) {
		global $db;
		return $db->get_assoc("SELECT * FROM artists WHERE artist = '".$db->esc($artist)."'");
	}

	function get_genre_info($genre) {
		global $db;
		return $db->get_assoc("SELECT * FROM genres WHERE genre = '".$db->esc($genre)."'");
	}

	function get_song_info($file) {
		global $db;
		$file = realpath($file);
		return $db->get_assoc("SELECT * FROM files f WHERE filename = '".$db->esc($file)."'");
	}


	function ext($file) {
		return strtolower(end(explode('.',basename($file))));
	}

	function add_missing_songs($uid) {
		global $db;
		$db->query("INSERT IGNORE INTO user_song_info (uid,state,rating,fid) SELECT '$uid','unplayed','11', f.fid FROM files f LEFT JOIN user_song_info u ON f.fid = u.fid AND u.uid = '$uid' WHERE u.fid IS NULL");
	}

	function add_all_missing_songs() {
		global $db;
		$users = $db->get_results_assoc("SELECT uid FROM users");
		foreach ($users as $uinfo) {
			add_missing_songs($uinfo['uid']);
		}
		// Clean the database.
		// Create remove_from_users
		$db->query("CREATE TEMPORARY TABLE `remove_from_users` (`fid` int(11) NOT NULL, UNIQUE KEY `fid` (`fid`))");
		// Find missing fids in user_song_info
		// SELECT DISTINCT u.fid FROM user_song_info u LEFT JOIN files f USING(fid) WHERE f.fid IS NULL;
		$db->query("INSERT IGNORE INTO remove_from_users (fid) SELECT DISTINCT u.fid FROM user_song_info u LEFT JOIN files f USING(fid) WHERE f.fid IS NULL");
		// Remove missing fids from user_song_info table.
		$db->query("DELETE remove_from_users r, user_song_info u FROM remove_from_users r, user_song_info u WHERE r.fid = u.fid");
		$db->query("DROP TABLE remove_from_users");


		// Create remove_from_genres
		$db->query("CREATE TEMPORARY TABLE `remove_from_genres` (`gid` int(11) NOT NULL, UNIQUE KEY `gid` (`gid`))");
		// Find missing gids in genres
		// SELECT DISTINCT g.gid FROM genres g LEFT JOIN files f USING(gid) WHERE f.gid IS NULL;
		$db->query("INSERT IGNORE INTO remove_from_genres (gid) SELECT DISTINCT g.gid FROM genres g LEFT JOIN files f USING(gid) WHERE f.gid IS NULL");
		// Remove missing gids from genres
		$db->query("DELETE remove_from_genres r, genres g FROM remove_from_genres r, genres g WHERE r.gid = g.gid");
		$db->query("DROP TABLE remove_from_genres");

		// Create `remove_from_artists`
		$db->query("CREATE TEMPORARY TABLE `remove_from_artists` (`aid` int(11) NOT NULL, UNIQUE KEY `aid` (`aid`))");
		// Find missing aids in artists
		// SELECT DISTINCT a.aid FROM artists a LEFT JOIN files f USING(aid) WHERE f.aid IS NULL;
		$db->query("INSERT IGNORE INTO remove_from_artists (aid) SELECT DISTINCT a.aid FROM artists a LEFT JOIN files f USING(aid) WHERE f.aid IS NULL");
		// Remove missing aids from artists
		$db->query("DELETE remove_from_artists r, artists a FROM remove_from_artists r, artists a WHERE r.aid = a.aid");
		$db->query("DROP TABLE remove_from_artists");

	}

	function is_converted($file) {
		if (!must_convert($file['filename'])) {
			return true;
		}
		clearstatcache();
		$f1 = 'converted/'.$file['fid'].'.mp3';
		$f2 = 'converted/'.$file['fid'].'.flv';
		if (file_exists($f1) || file_exists($f2)) {
			return true;
		}
		return false;
	}

	function must_convert($filename) {
		$ext = ext($filename);
		global $must_convert_ext;
		if (in_array($ext, $must_convert_ext)) {
			return true;
		} else {
			return false;
		}
	}

	function is_video($filename) {
		global $video_ext;
		$ext = ext($filename);
		if (in_array($ext,$video_ext)) {
			return true;
		}
		return false;
	}

	function parse_size($string) {
		$size = 0;
		$sizes = array (
			'K' => 1024,
			'M' => (1024 * 1024),
			'G' => (1024 * 1024 * 1024)
		);

		foreach ($sizes as $l=>$s) {
			if (preg_match_all('/([\d|\.]+)'.$l.'/i',$string,$matches, PREG_SET_ORDER)) {
				foreach ($matches as $match) {
					$string = str_replace($match[0],'',$string);
					$size = $size + ($s * $match[1]);
				}
			}
		}

		$string = trim($string);
		if (is_numeric($string)) {
			$size = $size + $string;
		}
		return floor($size);
	}

	function safe_string($string) {
		$pattern = array('/([^\w\ \-\.\,\'\&])/i','/(&)/i');
		$replacement = array('_','and');
		return preg_replace($pattern, $replacement, $string);
	}

	function fileSize2human($size) {
		// this function taken from: http://www.craigfrancis.co.uk/features/code/phpHumanFileSize/
		$units = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
		foreach ($units as $unit) {
			if ($size >= 1024 && $unit != 'YB') {
				$size = ($size / 1024);
			} else {
				return round($size, 0) . $unit;
			}
		}
	}

	function playlist_link($link_text = 'Link here') {
		$fids = array();
		if (isset($_SESSION['playlist'])) {
			foreach ($_SESSION['playlist'] as $k=>$f) {
				$fids[] = $f['fid'];
			}
		}
		ob_start();
		?><a href="?playlist=<?php echo implode(',',$fids); ?>&currentItem=<?php echo $_SESSION['currentItem']; ?>"><?php
		eent($link_text); ?></a><?php
		$x = ob_get_clean();
		echo $x."<br />";
		// eent($x);
	}

	function highlight($string) {
		$string = highlight_string('<?php '.$string.' ?>', true);
		$find = array('&lt;?php','?&gt;');
		$replace = '';
		return str_replace($find, $replace, $string);
	}

	function cue_for_convertsion($file) {
		global $db;
		$db->query("INSERT IGNORE INTO to_convert (fid, session_id, converted, cue_time) VALUES('".$db->esc($file['fid'])."', '".$db->esc(session_id())."', '0', NOW())");
		if (!is_converted($file)) {
			$db->query("UPDATE to_convert SET converted = '0' WHERE fid = '".$db->esc($file['fid'])."'");
		}
	}

	function get_ext($filename) {
		return strtolower(end(explode('.',basename($filename))));
	}

?>