<?php
$creates = array();
$creates['artists'] = "CREATE TABLE `artists` (
  `aid` int(11) NOT NULL auto_increment,
  `artist` varchar(255) NOT NULL,
  `altp` datetime NOT NULL,
  `artist_not_on_cd` tinyint(1) NOT NULL,
  PRIMARY KEY  (`aid`),
  KEY `artist` (`artist`),
  KEY `altp` (`altp`),
  KEY `artist_not_on_cd` (`artist_not_on_cd`)
) ENGINE=MyISAM AUTO_INCREMENT=4181 DEFAULT CHARSET=latin1";

$creates['file_data'] = "CREATE TABLE `file_data` (
  `fid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` blob NOT NULL,
  UNIQUE KEY `fid` (`fid`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['files'] = "CREATE TABLE `files` (
  `fid` int(11) NOT NULL auto_increment,
  `aid` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `gid` int(11) NOT NULL,
  `fileformat` varchar(4) NOT NULL,
  `playtime_seconds` double NOT NULL,
  `bitrate` int(11) NOT NULL,
  `sample_rate` int(11) NOT NULL,
  `track` varchar(20) NOT NULL,
  `year` int(4) NOT NULL,
  `filename` varchar(400) NOT NULL,
  `ltp` datetime NOT NULL,
  `filesize` int(11) NOT NULL,
  `add_to_cd` tinyint(1) NOT NULL,
  PRIMARY KEY  (`fid`),
  UNIQUE KEY `filename` (`filename`),
  KEY `aid` (`aid`),
  KEY `title` (`title`),
  KEY `gid` (`gid`),
  KEY `ltp` (`ltp`),
  KEY `playtime_seconds` (`playtime_seconds`),
  KEY `bitrate` (`bitrate`),
  KEY `track` (`track`),
  KEY `year` (`year`),
  KEY `filesize` (`filesize`),
  KEY `add_to_cd` (`add_to_cd`),
  KEY `sample_rate` (`sample_rate`)
) ENGINE=MyISAM AUTO_INCREMENT=20389 DEFAULT CHARSET=latin1";

$creates['files_to_scan'] = "CREATE TABLE `files_to_scan` (
  `filename` varchar(400) NOT NULL,
  UNIQUE KEY `filename` (`filename`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['genres'] = "CREATE TABLE `genres` (
  `gid` int(11) NOT NULL auto_increment,
  `id1` int(3) NOT NULL,
  `genre` varchar(255) NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `pick_from_for_cd` tinyint(1) NOT NULL,
  PRIMARY KEY  (`gid`),
  KEY `id1` (`id1`),
  KEY `genre` (`genre`),
  KEY `pick_from_for_cd` (`pick_from_for_cd`)
) ENGINE=MyISAM AUTO_INCREMENT=630 DEFAULT CHARSET=latin1";

$creates['remember_me'] = "CREATE TABLE `remember_me` (
  `cookie_id` varchar(34) NOT NULL,
  `session` mediumtext NOT NULL,
  `last_used` date NOT NULL,
  `uid` int(11) NOT NULL,
  `ip` varchar(16) NOT NULL,
  PRIMARY KEY  (`cookie_id`),
  KEY `last_used` (`last_used`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['to_convert'] = "CREATE TABLE `to_convert` (
  `fid` int(11) NOT NULL,
  `session_id` varchar(255) NOT NULL,
  `converted` tinyint(1) NOT NULL,
  `cue_time` datetime NOT NULL,
  UNIQUE KEY `fid` (`fid`,`session_id`),
  KEY `cue_time` (`cue_time`),
  KEY `converted` (`converted`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['user_artist_info'] = "CREATE TABLE `user_artist_info` (
  `uid` int(11) NOT NULL,
  `aid` int(11) NOT NULL,
  `ualtp` datetime NOT NULL,
  UNIQUE KEY `uid_aid` (`uid`,`aid`),
  KEY `ualtp` (`ualtp`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['user_data'] = "CREATE TABLE `user_data` (
  `uid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY  (`uid`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['user_genres'] = "CREATE TABLE `user_genres` (
  `uid` int(11) NOT NULL,
  `gid` int(11) NOT NULL,
  UNIQUE KEY `uid_gid` (`uid`,`gid`),
  KEY `uid` (`uid`),
  KEY `gid` (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['user_settings'] = "CREATE TABLE `user_settings` (
  `uid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  UNIQUE KEY `uid` (`uid`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['user_song_info'] = "CREATE TABLE `user_song_info` (
  `fid` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `rating` int(2) NOT NULL,
  `state` enum('unplayed','cued','played') NOT NULL default 'unplayed',
  `ultp` datetime NOT NULL,
  UNIQUE KEY `fid_uid` (`fid`,`uid`),
  KEY `state` (`state`),
  KEY `rating` (`rating`),
  KEY `uid` (`uid`),
  KEY `ultp` (`ultp`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1";

$creates['users'] = "CREATE TABLE `users` (
  `uid` int(11) NOT NULL auto_increment,
  `uname` varchar(255) NOT NULL,
  `pword` varchar(255) NOT NULL,
  `admin` tinyint(1) NOT NULL default '0',
  `level` tinyint(3) NOT NULL default '1',
  `member_since` datetime NOT NULL,
  `last_login` datetime NOT NULL,
  PRIMARY KEY  (`uid`),
  KEY `uname` (`uname`),
  KEY `pword` (`pword`),
  KEY `admin` (`admin`),
  KEY `last_login` (`last_login`),
  KEY `member_since` (`member_since`)
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=latin1";


?>