
// BrowserDetect stolen from http://www.quirksmode.org/js/detect.html
var BrowserDetect = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "an unknown version";
		this.OS = this.searchString(this.dataOS) || "an unknown OS";
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "Safari"
		},
		{
			prop: window.opera,
			identity: "Opera"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
		],
	dataOS : [
			{
				string: navigator.platform,
				subString: "Win",
				identity: "Windows"
			},
			{
				string: navigator.platform,
				subString: "Mac",
				identity: "Mac"
			},
			{
				string: navigator.platform,
				subString: "Linux",
				identity: "Linux"
			}
		]

};
BrowserDetect.init();


var player = {
	so: null,
	playlist: [],
	mpl: null,
	currentPosition: 0,
	locked: false,
	state: -1,
	playlistIds: [],
	users: [],
	// Format rating[id][uid] = rating
	ratings: [],
	idsWithEmptyFinfo: [],
	idsWithEmptyRatings: [],
	lastItemData: {id:0},
	lastItem: 0,
	lastPlaylist: [],
	trimLocked: false,
	preload: [],
	fileInfo: [],
	userPickOrder: [],
	init: function(movieName, div) {
		this.mpl = movieName;
		this.mpl = 'playerId';
		if (BrowserDetect.browser == 'Firefox') {
			this.so = new SWFObject('mediaplayer.swf',this.mpl, '100%', '100%', '7');
		} else {
			this.so = new SWFObject('mediaplayer.swf',this.mpl, '100%', 200, '7');
		}
		this.so.addParam('allowfullscreen','true');
		this.so.addParam('allowscriptaccess','true');
		this.so.addVariable('file','playlist.xml.php');
		this.so.addVariable('repeat','list');
		this.so.addVariable('shuffle','false');
		this.so.addVariable('enablejs','true');
		this.so.addVariable("autostart","false");
		this.so.addVariable("displayheight","9999");
		// this.so.write(div);
		this.so.write('player');
	},
	movie: function() {
		if(navigator.appName.indexOf("Microsoft") != -1) {
			return window[this.mpl];
		} else if(navigator.appName.indexOf("Opera") != -1) {
			return document.getElementById(this.mpl);
		} else if (document[this.mpl]) {
			return document[this.mpl];
		} else {
			if (document.getElementById(this.mpl)) {
				return document.getElementById(this.mpl);
			}
		}
	},
	getPlaylist: function() {
		this.playlist = [];
		this.playlistIds = [];
		var i = 0;
		var loop_forever = true;
		var c = "";
		while (loop_forever) {
			try {
				var obj = this.itemData(i);
				if (typeof(obj) == 'undefined' || typeof(obj['id']) == 'undefined') {
					return;
				}
				this.playlist.push(obj);
				this.playlistIds.push(obj['id']);
				var fid = obj['id'];
				// fid is a number.
				try {
					for (uid in this.users) {
						if (typeof(ratings[uid]) == 'undefined') {
							ratings[uid] = {};
							this.idsWithEmptyRatings.push({uid:fid});
						} else if (typeof(ratings[uid][fid]) == 'undefined')  {
							ratings[uid][fid] = '-';
							this.idsWithEmptyRatings.push({uid:fid});
						}
					}
				} catch (e) {

				}
				if (!isNaN(fid)) {
					if (typeof(this.fileInfo[fid]) == 'undefined' || !this.fileInfo[fid]) {
						this.idsWithEmptyFinfo.push(fid);
					}
				}

			} catch (e) {
				return;
			}
			i++;
		}
	},
	playlist_header: "<ol>",
	playlist_normal_template: "<li><a onClick='player.playItem(%pos%);'>%artist% - %title%</a></li>",
	playlist_current_template: "<li class='c'><a onClick='player.playItem(%pos%);'>%artist% - %title%</a></li>",
	playlist_footer: "</ol><input type='button' value='Load New Playlist' onClick='player.loadFileAndPlay(\"playlist.xml.php?new\");'>",
	getPlaylistContents: function() {
		this.getPlaylist();
		if (this.playlist.length == 0) {
			return "Empty Playlist";
		}
		var c = this.playlist_header;
		var t;
		for (i=0;i<this.playlist.length;i++) {
			if (i == this.currentItem) {
				t = this.playlist_current_template;
			} else {
				t = this.playlist_normal_template;
			}
			t = t.replace(/%pos%/, i);
			t = t.replace(/%artist%/, this.playlist[i]['author']);
			t = t.replace(/%title%/, this.playlist[i]['title']);
			// Get the id of the current playlist item.
			c += t;
		}
		c += this.playlist_footer;
		return c;
	},
	setPlaylistContents: function() {
		try {
			document.getElementById('playlist_test').innerHTML = this.getPlaylistContents();
		} catch (e) {
			//
		}
	},
	itemData: function(idx) {
		return this.movie().itemData(idx);
	},
	setCurrentItem: function(idx) {
		this.currentItem = idx;
		this.currentItemData = this.movie().itemData(idx);
		this.setPlaylistContents();
		if (this.currentItemData && this.currentItemData['id'] == 'load' && !this.locked && !this.trimLocked) {
			this.loadFileAndPlay("playlist.xml.php?new");
		}
		if (this.currentItem > 7) {
			this.trimPlaylist();
		}
	},
	trimPlaylist: function() {
		if (this.trimLocked) {
			return;
		}
		this.trimLocked = true;
		// clearDebug();
		// Yes we want it temporary
		var currentItem = this.currentItem;
		while (currentItem > 4) {
			this.removeItem(0);
			currentItem--;
		}
		this.currentItem = currentItem;
		// this.trimLocked=false;
		// this.locked=false;
		// this.getPlaylist();
		// alert("called trimPlaylist");
		setTimeout('player.trimLocked=false;player.addSongs();',1000);
	},
	sync: function() {
		if (this.locked || this.trimLocked) {
			return;
		}
		this.locked = true;
		var timeToSync = false;
		var syncObj = {};
		if (this.playlist.length == 0) {
			// never sync when the playlist is empty
			this.locked = false;
			return;
		}
		if (this.playlist.length < 10) {
			timeToSync = true;
			// cue preload.
		}
		if (this.idsWithEmptyRatings.length > 0) {
			timeToSync = true;
			syncObj["emptyRatings"] = this.idsWithEmptyRatings;
		}
		if (this.idsWithEmptyFinfo.length > 0) {
			timeToSync = true;
			syncObj["emptyFinfo"] = this.idsWithEmptyFinfo;
		}
		try {
			if (this.currentItemData['id'] != this.lastItemData['id'] || this.currentItem != this.lastItem || !samePlaylists(this.lastPlaylist, this.playlist)) {
				timeToSync = true;
				syncObj["playlist"] = this.playlistIds;
				syncObj["currentItem"] = this.currentItem;
				syncObj["currentItemId"] = this.currentItemData['id'];
			}
		} catch(e) {
			this.locked = false;
			// Wait a second and see what happens.
			setTimeout('player.sync();',1000);
			return;
		}
		syncObj["preload"] = this.preload;
		// ADD IM HERE
		if (!timeToSync) {
			// sync not needed.
			this.locked = false;
			return;
		}
		this.lastItem = this.currentItem;
		this.lastPlaylist = this.playlist;
		this.lastItemData = this.currentItemData;
		// sync with server now.
		// send preload information, and playlist info.
		// Force an unlock in 10 seconds.
		xajax_sync(syncObj);
		setTimeout("player.locked=false;",10000);
	},
	sendEvent: function (typ,prm) {
		this.movie().sendEvent(typ,prm);
	},
	loadFile: function (obj) {
		this.movie().loadFile(obj);
	},
	loadFileAndPlay: function (fileName) {
		this.playItem(0); // set the index to 0
		this.stop();
		this.movie().loadFile({file:fileName});
		setTimeout('player.playItem(0);',1000);
	},
	addItem: function (obj,idx) {
		this.movie().addItem(obj,idx);
	},
	removeItem: function (idx) {
		this.movie().removeItem(idx);
	},
	playItem: function(idx) {
		this.sendEvent('playitem',idx);
	},
	play: function() {
		// State:0 == paused/stopped.
		// State:1 == buffering -- guess
		// State:2 == playing
		if (this.state == 0) {
			this.sendEvent('playitem',this.currentItem);
		}
	},
	stop: function() {
		// State:0 == paused/stopped.
		// State:1 == buffering -- guess
		// State:2 == playing
		this.sendEvent('stop');
	},
	setRating: function(uid,fid,rating) {
		if (typeof(this.rating[uid]) == 'undefined') {
   			this.rating[uid] = {fid:rating};
   			return;
		}
		this.rating[uid][fid] = rating;
	},
	next: function() {
		this.sendEvent('next');
	},
	setFileInfo: function(fid, fileInfo) {
		this.fileInfo[fid] = fileInfo;
	},
	addSongs: function () {
		this.getPlaylist();
		while (this.playlist.length < 10) {
			if (this.users.length > 0) {
				uid = this.userPickOrder.pop();
				this.userPickOrder.unshift(uid);
			} else {
				uid = 'nobody';
			}
			var fid = addSongFromPreload('nobody');
			if (!fid) {
				return;
			}
			if (typeof(this.fileInfo[fid]) == 'undefined') {
				// it should be there, but just in case.
				this.idsWithEmptyFinfo.push(fid);
			} else {
				this.addItem(this.fileInfo[fid]);
			}
		}
		this.sync();
	},
	addSongFromPreload: function (uid) {
		if (this.preload[uid].length == 0) {
			return false;
		}
		return this.preload[uid].pop();
	}
};

function getUpdate(typ,pr1,pr2,pid) {
	if(typ == "time") { player.currentPosition = pr1; }
	else if(typ == "volume") { player.currentVolume = pr1; }
	else if(typ == "item") {
		 // player.currentItem = pr1;
		 setTimeout("player.setCurrentItem("+pr1+");",100);
	} else if (typ == "state") {
		player.state = pr1;
	}
	var id = document.getElementById(typ);
	id.innerHTML = typ+ ": "+Math.round(pr1);
	pr2 == undefined ? null: id.innerHTML += ", "+Math.round(pr2);
	if(pid != "null") {
		document.getElementById("pid").innerHTML = "(received from the player with id <i>"+pid+"</i>)";
	}
};

function samePlaylists (playlist1, playlist2) {
	if (playlist1.length != playlist2.length) {
		return false;
	}
	for(i=0;i<playlist1.length;i++) {
		if (playlist1[i]['id'] != playlist1[i]['id']) {
			return false;
		}
	}
	return true;
}
