<?php
	session_start();
	ob_start();
	include_once 'config.inc.php';
	ob_clean();
	include_once 'inc/common.inc.php';
	include_once 'class/db.class.php';
	include_once 'class/html.class.php';
	require_once 'xajax_core/xajax.inc.php';
	include_once 'class/callback.class.php';

	if (!is_admin()) {
		die("You are not allowed to enter this page.");
	}

	global $db, $html, $xajax, $callback;
	$db = new db(DB_HOST, DB_NAME, DB_UNAME, DB_PWORD, $die = true);
	$html = new html();

	$genres = $db->get_results_assoc("SELECT * FROM genres ORDER BY genre",'gid');

	if (!isset($_SESSION['cd'])) {
		$_SESSION['cd'] = array(
			'min' => 7,
			'max' => 10,
			'max_per_artist' => 5,
			'files' => array(),
			'dont_pick' => array(),
			'size' => '2G',
			'dont_pick_artist' => array(),
			'genres' => $genres
		);
	}

	function parse_size($string) {
		$size = 0;
		$sizes = array (
			'K' => 1000,
			'M' => 1000000,
			'G' => 1000000000
		);

		foreach ($sizes as $l=>$s) {
			if (preg_match_all('/([\d|\.]+)'.$l.'/i',$string,$matches, PREG_SET_ORDER)) {
				foreach ($matches as $match) {
					$string = str_replace($match[0],'',$string);
					$size = $size + ($s * $match[1]);
				}
			}
		}

		$string = trim($string);
		if (is_numeric($string)) {
			$size = $size + $string;
		}
		return floor($size);
	}



	if(isset($_POST['action']) && $_POST['action'] == 'Fetch Files') {
		if (!is_numeric($_POST['min'])) {
			$_SESSION['cd']['min'] = 7;
		} else {
			$_SESSION['cd']['min'] = $_POST['min'];
		}
		if (!is_numeric($_POST['max'])) {
			$_SESSION['cd']['max'] = 10;
		} else {
			$_SESSION['cd']['max'] = $_POST['max'];
		}
		if (!is_numeric($_POST['max_per_artist'])) {
			$_SESSION['cd']['max_per_artist'] = 5;
		} else {
			$_SESSION['cd']['max_per_artist'] = $_POST['max_per_artist'];
		}
		$_SESSION['cd']['genres'] = $_POST['genres'];
		if (isset($_POST['dont_pick'])) {
			$_SESSION['cd']['dont_pick'] = $_POST['dont_pick'];
		} else {
			$_SESSION['cd']['dont_pick'] = array();
		}
		// Create a table of files not to pick
		$db->equery("CREATE TEMPORARY TABLE `dont_pick` (`fid` int(11) NOT NULL, UNIQUE KEY `fid` (`fid`))");
		foreach ($_SESSION['cd']['dont_pick'] as $k=>$v) {
			if (!is_numeric($v)) {
				unset($_SESSION['cd']['dont_pick']["$k"]);
			}
		}
		if (!empty($_SESSION['cd']['dont_pick'])) {
			$db->equery("INSERT IGNORE INTO dont_pick (fid) VALUES(".implode('),(',$_SESSION['cd']['dont_pick']).")");
		}
		foreach ($_SESSION['cd']['dont_pick_artist'] as $k=>$v) {
			if (!is_numeric($v)) {
				unset($_SESSION['cd']['dont_pick_artist']["$k"]);
			}
		}
		if (!empty($_SESSION['cd']['dont_pick_artist'])) {
			$db->equery("INSERT IGNORE INTO dont_pick (fid) SELECT fid FROM files WHERE aid IN (".implode(',', $_SESSION['cd']['dont_pick_artist']) . ")");
		}
		$db->equery("CREATE TEMPORARY TABLE `do_pick_genres` (`gid` int(11) NOT NULL, UNIQUE KEY `gid` (`gid`))");
		$gids = array();
		foreach ($_SESSION['cd']['genres'] as $gid=>$v) {
			if (is_numeric($gid)) {
				$gids[] = $gid;
			}
		}
		$db->equery("INSERT IGNORE INTO do_pick_genres (gid) VALUES(".implode('),(',$gids).")");
		$uids = array_keys($_SESSION['users']);
		$uids = implode(',',$uids);
		$db->equery("INSERT IGNORE INTO dont_pick (fid) SELECT fid FROM user_song_info WHERE uid IN ($uids) AND rating = 0");

		$size = parse_size('2G');
		// Average File size
		$avg = floor($db->get_var("SELECT AVG(filesize) AS files FROM files f, user_song_info u WHERE f.fid = u.fid AND u.uid IN($uids) AND u.rating != 0 AND u.rating >= 7 AND u.rating <= 10"));

		// Figure out how many files can be selected
		$limit = floor($size / $avg);

		$files = $db->get_results_assoc("SELECT f.fid, artist, title, filename, filesize FROM files f LEFT JOIN dont_pick dp ON dp.fid = f.fid, artists a, user_song_info u, do_pick_genres dg, genres g WHERE f.gid = dg.gid AND dp.fid IS NULL AND u.uid IN ($uids) AND g.gid = f.gid AND u.fid = f.fid AND f.aid = a.aid AND u.rating >= '".$_SESSION['cd']['min']."' AND u.rating <= '".$_SESSION['cd']['max']."' ORDER BY add_to_cd DESC, rand() LIMIT $limit",'fid');

		// $_SESSION['cd']['files'] = $files;
		$artist_cnt = array();
		$_SESSION['cd']['files'] = array();
		if (!empty($_POST['sticky'])) {
			foreach ($_POST['sticky'] as $fid)  {
				if (!is_numeric($fid)) {
					continue;
				}
				if (isset($files["$fid"])) {
					$f = $files["$fid"];
				} else {
					$f = $db->get_assoc("SELECT f.fid, artist, title, filename, filesize FROM files f, artists a WHERE f.fid = '$fid' AND a.aid = f.aid");
				}
				$_SESSION['cd']['files']["{$f['artist']} - {$f['title']}"] = $f;
			}
		}
		foreach ($files as $k=>$f) {
			if (!isset($artist_cnt["{$f['artist']}"])) {
				$artist_cnt["{$f['artist']}"] = 1;
			}
			if ($artist_cnt["{$f['artist']}"] > $_POST['max_per_artist']) {
				//$artist_cnt["{$f['artist']}"] = 1;
				continue;
			}
			$_SESSION['cd']['files']["{$f['artist']} - {$f['title']}"] = $f;
			$artist_cnt["{$f['artist']}"]++;
		}

		ksort($_SESSION['cd']['files']);

		/*
		SELECT artist, title, filesize FROM files f, user_song_info u, artists a WHERE f.fid = u.fid AND a.aid = f.aid AND u.rating >= 7 AND u.rating <= 10 AND u.uid IN (1,2,3,4) AND u.rating != 0 ORDER BY rand() LIMIT 100;
		*/
	} elseif (isset($_POST['action']) && $_POST['action'] == 'Copy Files') {
		function safe_string($string) {
			$pattern = array('/([^\w\ \-\.\,\'\&])/i','/(&)/i');
			$replacement = array('_','and');
			return preg_replace($pattern, $replacement, $string);
		}
		shuffle($_SESSION['cd']['files']);
		foreach ($_SESSION['cd']['files'] as $k=>$f) {
			if (in_array($f['fid'], $_POST['dont_pick'])) {
				$_SESSION['cd']['dont_pick'][] = $f;
				continue;
			}
			set_time_limit(0);
			$dst = 'cd/'.str_pad($k, 3, "0", STR_PAD_LEFT).' '.safe_string($f['artist'].' - '.$f['title'].'.mp3');
			echo $dst."<br />\n";
			copy($f['filename'], $dst);
		}
		exit;
	}

?>
<script type="text/javascript"><!--
	function play(fid) {
		/* ?><object type="application/x-shockwave-flash" width="17" height="17" data="musicplayer.swf?autoload=false&song_url=stream.php?fid=<?php echo $f['fid'];?>"><param name="movie" value="musicplayer.swf?autoload=false&song_url=stream.php?fid=<?php echo $f['fid'];?>" /></object> */

		var content = "";
		content+= "<object type='application/x-shockwave-flash' width='17' height='17' id='swf["+fid+"]' data='musicplayer.swf?song_url=stream.php?fid="+fid+"'><param name='movie' value='musicplayer.swf?song_url=stream.php?fid="+fid+"' /></object>";
		document.getElementById("player["+fid+"]").onClick = '';
		document.getElementById("player["+fid+"]").innerHTML=content;
		document.getElementById("swf["+fid+"]").play();
	}
//-->
</script>
<form method="post">
	Min Rating:<input type="text" size=2 name="min" value="<?php echo $_SESSION['cd']['min']; ?>"><br />
	Max Rating:<input type="text" size=2 name="max" value="<?php echo $_SESSION['cd']['max']; ?>"><br />
	Max Songs Per Artist:<input type="text" size=2 name="max_per_artist" value="<?php echo $_SESSION['cd']['max_per_artist']; ?>"><br />
	<input type="submit" name="action" value="Fetch Files"><br />
	<h3>Pick From These Genres</h3>
	<?php
	foreach ($genres as $gid=>$genre) {
		?><input type="checkbox" name="genres[<?php echo $gid; ?>]" id="genres[<?php echo $gid; ?>]" value="<?php echo $gid; ?>"<?php
			if (isset($_SESSION['cd']['genres']["$gid"])) {
				echo ' checked';
			}
		?>><label for="genres[<?php echo $gid; ?>]"><?php eent($genre['genre']); ?></label><br /><?php
	}
	?><input type="submit" name="action" value="Fetch Files">
	<h3>Files</h3><br /><?php
	$running_total = 0;
	$cnt = 0;
	foreach ($_SESSION['cd']['files'] as $fid=>$f) {
		//song_url
		/*
   			<object type="application/x-shockwave-flash" width="17" height="17" data="musicplayer.swf?&song_url=stream.php?fid=<?php echo $f['fid'];?>.mp3"><param name="movie" value="musicplayer.swf?&song_url=stream.php?fid=<?php echo $f['fid'];?>.mp3" /></object>
		*/
		?><input type="checkbox" name="sticky[]" value="<?php echo $f['fid']; ?>"<?php
		if (!empty($_POST['sticky']) && in_array($f['fid'], $_POST['sticky'])) {
			?> checked<?php
		}
		?>><input type="checkbox" name="dont_pick[]" value="<?php echo $f['fid']; ?>" id="file[<?php echo $f['fid']; ?>]"><input type="checkbox" name="dont_pick_artist[]" value="<?php echo $f['aid']; ?>"><?php
			$cnt++;
			if ($cnt <= 10) {
				/* ?><object type="application/x-shockwave-flash" width="17" height="17" data="musicplayer.swf?autoload=false&song_url=stream.php?fid=<?php echo $f['fid'];?>"><param name="movie" value="musicplayer.swf?autoload=false&song_url=stream.php?fid=<?php echo $f['fid'];?>" /></object><?php */
			}

		?><span id="player[<?php echo $f['fid']; ?>]" onClick="play(<?php echo $f['fid']; ?>);" style="cursor:pointer;">[play]</span> <label for="file[<?php echo $f['fid']; ?>]"><?php eent($f['artist'].' - '.$f['title']) ?></label><br /><?php
		$running_total = $running_total + $f['filesize'];
	}
	echo "Total:$running_total";
	?>
	<input type="submit" name="action" value="Fetch Files"><br />
	<h3>Don't Pick These Songs</h3>
	<?php
		foreach ($_SESSION['cd']['dont_pick'] as $fid) {
			if (!is_numeric($fid)) {
				continue;
			}
			$f = $db->get_assoc("SELECT artist, title FROM files f, artists a WHERE fid = '$fid' AND f.aid = a.aid");
			?><input type="checkbox" name="dont_pick[]" value="<?php echo $fid; ?>" checked><?php eent($f['artist'].' - '.$f['title']) ?><br /><?php
		}
	?>
	<h3>Don't Pick These Artists</h3>
	<?php
		foreach ($_SESSION['cd']['dont_pick_artist'] as $aid) {
			if (!is_numeric($aid)) {
				continue;
			}
			$a = $db->get_assoc("SELECT artist, title FROM files WHERE fid = '$aid'");
			?><input type="checkbox" name="dont_pick[]" value="<?php echo $fid; ?>" checked><?php eent($aid['artist'].' - '.$aid['title']) ?><br /><?php
		}
	?>
	<input type="submit" name="action" value="Copy Files"><br />
</form>
<pre>
<?php
	// print_r($_SESSION['cd']);
	// print_r($files);

?>
</pre>