#!/usr/bin/php
<?php
	if (isset($_SERVER['REMOTE_ADDR'])) {
		echo "This file is for command line use only.";
		exit;
	}

	if (!isset($argv[1])) {
		echo 'usage: scan.php /path/to/files/'."\n";
		exit;
	}

	set_time_limit(0);
	include 'config.inc.php';
	include 'class/db.class.php';
	include 'inc/common.inc.php';
	global $file_types;
	$file_types = array(
		'mp3',
		'ogg',
		'mov',
		'mpg',
		'mpeg',
		'avi',
		'wav',
		'rm',
		'wmv',
		'flv',
		'divx');
	sort($file_types);
	$db = new db(DB_HOST, DB_NAME, DB_UNAME, DB_PWORD, $die = true);

	function cli_scan_dir($dir) {
		global $file_types;
		static $already_scanned = array();
		$dir = realpath($dir).'/';
		if (in_array($dir, $already_scanned)) {
			return;
		}
		$already_scanned[] = $dir;
		$c = chr(27).'[K';
		if (is_dir($dir)) {
			chmod ($dir,0775);
			chgrp($dir, 1000);
		}
		foreach (glob($dir.'*') as $file) {
			echo "scan:$file $c\r";
			$file = realpath($file);
			$ext = ext($file);
			if (is_dir($file)) {
				cli_scan_dir($file);
			} elseif (in_array($ext,$file_types)) {
				cli_scan_file($file);
			}
		}
	}

	add_all_missing_songs();
	function cli_scan_file($file) {
		global $db;
		$c = chr(27).'[K';
		$file = realpath($file);
		echo "scan:$file $c\r";
		// $file = realpath($file['filename']);
		// chmod ($file,0644);
		// chgrp ($file, 1000);
		$info = $db->get_assoc("SELECT * FROM files f, artists a, genres g WHERE filename = '".$db->esc($file)."' AND a.aid = f.aid AND f.gid = g.gid");
		if (!$info) {
			$tags = get_tags($file);
			update_tags($tags);
			return;
		} elseif (!$info['sample_rate']) {
			/* $tags = get_tags($file);
			// echo "info\n";
			// print_r($info);
			unset($info['sample_rate']);
			unset($info['bitrate']);
			$new_tags = array_merge ($tags, $info);
			// print_r($new_tags);
			$fid = $new_tags['fid'];
			unset($new_tags['fid']);
			$db->update('files', $new_tags , "fid = '$fid'", false); */
			return;
		}
		return;
	}

	if (file_exists($argv[1])) {
		if (is_dir($argv[1])) {
			cli_scan_dir($argv[1]);
		} else {
			cli_scan_file($argv[1]);
		}
	}
	add_all_missing_songs();

?>